| Face Engine SDK 5.35.0 A face detection, recognition and tracking engine.

Public Member Functions | List of all members
fsdk::ILivenessRGBMEstimator Struct Referenceabstract
Estimators

RGBM Liveness estimator interface. More...

`#include <ILivenessRGBMEstimator.h>`

Inheritance diagram for fsdk::ILivenessRGBMEstimator:

## Public Member Functions
virtual Result< FSDKError > | update (const Image &image, uint32_t iFrame, Image &background) const noexcept=0
| Prepare background method. Pass here every frame from the stream to extract background. More...
virtual Result< FSDKError > | estimate (const Image &image, const Detection &detection, const Image &background, LivenessRGBMEstimation &estimation) const noexcept=0
| Check if detection corresponds to person alive or not. More...
virtual Result< FSDKError > | update (fsdk::Span< const Image > images, fsdk::Span< const uint32_t > iFrames, fsdk::Span< Image > backgrounds) const noexcept=0
| Prepare backgrounds. Pass here every frame from each stream to extract stream backgrounds. More...
virtual Result< FSDKError > | estimate (Span< const Image > images, Span< const Detection > detections, Span< const Image > backgrounds, Span< LivenessRGBMEstimation > estimation) const noexcept=0
| Check if detections correspond to alive persons. More...
Public Member Functions inherited from fsdk::IRefCounted
virtual int32_t | retain () noexcept=0
| Increase strong reference count. More...
virtual int32_t | retainLocked () noexcept=0
| Increase strong reference count thread safely. More...
virtual int32_t | release () noexcept=0
| Decrease strong reference count. More...
virtual int32_t | getRefCount () const noexcept=0
| Get actual strong reference count. More...
virtual int32_t | retainWeak () noexcept=0
| Increase weak reference count. More...
virtual int32_t | releaseWeak () noexcept=0
| Decrease weak reference count. More...
virtual int32_t | getWeakRefCount () const noexcept=0
| Get actual weak reference count. More...

## Detailed Description

RGBM Liveness estimator interface.

Note
  This estimator is designed for liveness detection.

## Member Function Documentation

## ◆ estimate() [1/2]

virtual Result<FSDKError> fsdk::ILivenessRGBMEstimator::estimate | ( | const Image & | image,
|  | const Detection & | detection,
|  | const Image & | background,
|  | LivenessRGBMEstimation & | estimation
| ) |  | const
| pure virtualnoexcept

Check if detection corresponds to person alive or not.

Parameters

  [in] | image | source image.
  [in] | detection | detection coordinates in image space.
  [in] | background | background for the track.
  [in,out] | estimation | estimation structure

Returns
  Result with error code.

See also
  LivenessRGBMEstimation, Detection, Image, Result and FSDKError for details.

Note
  images format must be R8G8B8,

See also
  Format.

## ◆ estimate() [2/2]

virtual Result<FSDKError> fsdk::ILivenessRGBMEstimator::estimate | ( | Span< const Image > | images,
|  | Span< const Detection > | detections,
|  | Span< const Image > | backgrounds,
|  | Span< LivenessRGBMEstimation > | estimation
| ) |  | const
| pure virtualnoexcept

Check if detections correspond to alive persons.

Parameters

  [in] | images | span of source images, one image per stream
  [in] | detections | span of detection coordinates in image space.
  [in] | backgrounds | span of backgrounds.
  [in,out] | estimation | span of estimation results

Returns
  Result with error code.

See also
  Span, LivenessRGBMEstimation, Detection, Image, Result and FSDKError for details.

Note
  images format must be R8G8B8,

See also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.

## ◆ update() [1/2]

virtual Result<FSDKError> fsdk::ILivenessRGBMEstimator::update | ( | const Image & | image,
|  | uint32_t | iFrame,
|  | Image & | background
| ) |  | const
| pure virtualnoexcept

Prepare background method. Pass here every frame from the stream to extract background.

Parameters

  [in] | image | source image.
  [in] | iFrame | current frame number.
  [in,out] | background | current background. It will be updated by this call. Memory residence (host/gpu) of background image can be changed because of internal implementation.

Returns
  Result with error code.

See also
  Image, Result and FSDKError for details.

Note
  image format must be R8G8B8,

See also
  Format.

## ◆ update() [2/2]

virtual Result<FSDKError> fsdk::ILivenessRGBMEstimator::update | ( | fsdk::Span< const Image > | images,
|  | fsdk::Span< const uint32_t > | iFrames,
|  | fsdk::Span< Image > | backgrounds
| ) |  | const
| pure virtualnoexcept

Prepare backgrounds. Pass here every frame from each stream to extract stream backgrounds.

Parameters

  [in] | images | span of source images.
  [in] | iFrames | span of current frame numbers.
  [in,out] | backgrounds | span of current background images. The images will be updated by this call. Memory residence (host/gpu) of background images can be changed because of internal implementation.

Returns
  Result with error code.

See also
  Span, Image, Result and FSDKError for details.

Note
  image format must be R8G8B8,

See also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.

The documentation for this struct was generated from the following file:

- include/fsdk/Estimators/ILivenessRGBMEstimator.h